#include <sourcemod>
#include <csgo_colors>
#include <shop>

#undef REQUIRE_PLUGIN
#include <shavit>

#pragma semicolon 1
#pragma newdecls required

public Plugin myinfo =
{
	name = "[Shop] Zone Credits",
	author = "Tonki_Ton",
	version = "1.4.0",
	url = "https://hlmod.ru"
};

enum
{
	BONUS,
	BONUSWR,
	WR,
	ONCE,
	CREDITS
};

ArrayList hWhoFinish;

char g_sCurrentMap[34];

int g_iCurrentPosition,
	g_iEventMode,
	g_iAmount[CREDITS],
	g_iPositionCredits[MAXPLAYERS+1];
	
bool g_bType,
	 g_bAllChat,
	 g_bSupportedMap;

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	MarkNativeAsOptional("Shop_GiveClientGold");
	return APLRes_Success;
}

public void OnPluginStart()
{
	HookEvent("round_start", OnRoundStart, EventHookMode_PostNoCopy);

	hWhoFinish = new ArrayList(ByteCountToCells(32));

	RegAdminCmd("sm_zc_reload", reload, ADMFLAG_ROOT);

	LoadTranslations("shop_zone_credits.phrases");
}

public Action reload(int client, int args) 
{
	PrintToConsole(client, "Конфиг перезагружен!");
	OnMapStart();

	return Plugin_Handled;
}

public void OnMapStart()
{
	GetCurrentMap(g_sCurrentMap, sizeof(g_sCurrentMap));
	LoadCfg();

	hWhoFinish.Clear();
}

public Action OnRoundStart(Event event, const char[] name, bool dontBroadcast)
{
	g_iCurrentPosition = 0;
}

//influx
public void Influx_OnTimerFinishPost( int client, int runid, int mode, int style, float time, float prev_pb, float prev_best, int flags)
{
	FinishMapEvent(client, (runid == 1) ? false:true, !(flags & (1 << 1)) ? false:true);
}

//shavit
public void Shavit_OnFinish(int client, int style, float time, int jumps, int strafes, float sync, int track)
{
	float WrTime;
	Shavit_GetWRTime(style, WrTime, track);

	FinishMapEvent(client, (track == 0) ? false:true, !(WrTime == 0.0 || time < WrTime) ? false:true);
}

//ZipCore Dr.Api fork
public void OnTimerRecord(int client, int track, int style, float time, float lasttime, int currentrank, int newrank)
{
	FinishMapEvent(client, (track == 0) ? false:true, (newrank != 1) ? false:true);
}

//ckSurf
public Action ckSurf_OnMapFinished(int client, float fRunTime, char sRunTime[54], int rank)
{
	FinishMapEvent(client, false, (rank != 1) ? false:true);
}

public Action ckSurf_OnBonusFinished(int client, float fRunTime, char sRunTime[54], int rank)
{
	FinishMapEvent(client, true, (rank != 1) ? false:true);
}

//blacky
public int OnTimerFinished_Post(int client, float Time, int Type, int Style, bool NewTime, int OldPosition, int NewPosition)
{
	FinishMapEvent(client, (Type == 1) ? false:true, (NewPosition != 1) ? false:true);
}

void FinishMapEvent(int client, bool bonus, bool wr)
{
	if (!g_bSupportedMap) return;

	if (!g_iEventMode && !bonus && g_iAmount[ONCE] > 0)
	{
		if (!g_bType) Shop_GiveClientCredits(client, g_iAmount[ONCE]);
		else Shop_GiveClientGold(client, g_iAmount[ONCE]);
		
		CGOPrintToChatAll("%t", g_bType ? "mapfinish_once_credits":"mapfinish_once_gold", client, g_iAmount[ONCE]);

		g_bSupportedMap = false;
	}
	else
	{
		if (g_iEventMode == 2) 
   		{
			char id[32];

			GetClientAuthId(client, AuthId_Steam2, id, sizeof(id), false);

			if (hWhoFinish.FindString(id) == -1) hWhoFinish.PushString(id);
			else if (hWhoFinish.FindString(id) != -1) return;
		}

		if (!bonus && !wr)
		{
			if (++g_iCurrentPosition > MAXPLAYERS) g_iCurrentPosition = MAXPLAYERS;
			if (g_iPositionCredits[g_iCurrentPosition] < 1) return;

			if (!g_bType) Shop_GiveClientCredits(client, g_iPositionCredits[g_iCurrentPosition]);
			else Shop_GiveClientGold(client, g_iPositionCredits[g_iCurrentPosition]);

			if (!g_bAllChat) CGOPrintToChat(client, "%t", !g_bType ? "MapFinish_Credits":"MapFinish_Gold", g_iPositionCredits[g_iCurrentPosition]);
			else CGOPrintToChatAll("%t", !g_bType ? "MapFinish_Credits_All":"MapFinish_Gold_All", client, g_iPositionCredits[g_iCurrentPosition]);
		}
		else if (!bonus && wr && g_iAmount[WR] > 0)
		{
			if (!g_bType) Shop_GiveClientCredits(client, g_iAmount[WR]);
			else Shop_GiveClientGold(client, g_iAmount[WR]);

			if (!g_bAllChat) CGOPrintToChat(client, "%t",  !g_bType ? "MapFinish_WR_Credits":"MapFinish_WR_Gold", g_iAmount[WR]);
			else CGOPrintToChatAll("%t", !g_bType ? "MapFinish_WR_Credits_All":"MapFinish_WR_Gold_All", client, g_iAmount[WR]);
		}

		if (bonus && !wr && g_iAmount[BONUS] > 0)
		{
			if (!g_bType) Shop_GiveClientCredits(client, g_iAmount[BONUS]);
			else Shop_GiveClientGold(client, g_iAmount[BONUS]);

			if (!g_bAllChat) CGOPrintToChat(client, "%t",  !g_bType ? "MapFinish_Bonus_Credits":"MapFinish_Bonus_Gold", g_iAmount[BONUS]);
			else CGOPrintToChatAll("%t", !g_bType ? "MapFinish_Bonus_Credits_All":"MapFinish_Bonus_Gold_All", client, g_iAmount[BONUS]);
		}
		else if (bonus && wr && g_iAmount[BONUSWR] > 0)
		{
			if (!g_bType) Shop_GiveClientCredits(client, g_iAmount[BONUSWR]);
			else Shop_GiveClientGold(client, g_iAmount[BONUSWR]);

			if (!g_bAllChat) CGOPrintToChat(client, "%t",  !g_bType ? "MapFinish_Bonus_WR_Credits":"MapFinish_Bonus_WR_Gold", g_iAmount[BONUSWR]);
			else CGOPrintToChatAll("%t", !g_bType ? "MapFinish_Bonus_WR_Credits_All":"MapFinish_Bonus_WR_Gold_All", client, g_iAmount[BONUSWR]);
		}
	}
}

void LoadCfg()
{
	char Buffer[128];

	KeyValues KvZc = new KeyValues("Credits");

	BuildPath(Path_SM, Buffer, sizeof(Buffer), "configs/shop/zone_credits.txt");
	if(!KvZc.ImportFromFile(Buffer))
	{
		SetFailState("Конфиг zone credits отсутсвует!");
	}
	else
	{
		KvZc.Rewind();

		g_iEventMode = KvZc.GetNum("zc_mode", 1);
		g_bAllChat = view_as<bool>(KvZc.GetNum("announce_to_all", 0));

		if (KvZc.JumpToKey(g_sCurrentMap, false))
		{
			g_bType = view_as<bool>(KvZc.GetNum("currency_type", 0));

			if (!g_iEventMode) g_iAmount[ONCE] = KvZc.GetNum("once_credits", 0);
			else
			{
				g_iAmount[BONUS] = KvZc.GetNum("bonus", 0);
				g_iAmount[BONUSWR] = KvZc.GetNum("bonus_wr", 0);
				g_iAmount[WR] = KvZc.GetNum("wr", 0);

				char sPos[10];
				for (int i = 1; i <= MAXPLAYERS; i++)
				{
					IntToString(i, sPos, sizeof(sPos));
					g_iPositionCredits[i] = KvZc.GetNum(sPos, -1);
					if (g_iPositionCredits[i] == -1)
					{
						g_iPositionCredits[i] = KvZc.GetNum("0");
					}
				}
			}
			g_bSupportedMap = true;
		}
		else g_bSupportedMap = false;
	}
	delete KvZc;
}